"""
    The version of the XENDIT API: 2.128.0
"""


import re  # noqa: F401
import sys  # noqa: F401
from typing import List  # noqa: F401

from xendit.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from xendit.exceptions import ApiAttributeError


def lazy_import():
    pass

class TokenizedCardInformation(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'token_id': (str, none_type),  # noqa: E501
            'masked_card_number': (str, none_type),  # noqa: E501
            'cardholder_name': (str, none_type, none_type),  # noqa: E501
            'expiry_month': (str, none_type),  # noqa: E501
            'expiry_year': (str, none_type),  # noqa: E501
            'fingerprint': (str, none_type),  # noqa: E501
            'type': (str, none_type),  # noqa: E501
            'network': (str, none_type),  # noqa: E501
            'country': (str, none_type),  # noqa: E501
            'issuer': (str, none_type),  # noqa: E501
            'card_number': (str, none_type),  # noqa: E501
            'one_time_token': (str, none_type),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'token_id': 'token_id',  # noqa: E501
        'masked_card_number': 'masked_card_number',  # noqa: E501
        'cardholder_name': 'cardholder_name',  # noqa: E501
        'expiry_month': 'expiry_month',  # noqa: E501
        'expiry_year': 'expiry_year',  # noqa: E501
        'fingerprint': 'fingerprint',  # noqa: E501
        'type': 'type',  # noqa: E501
        'network': 'network',  # noqa: E501
        'country': 'country',  # noqa: E501
        'issuer': 'issuer',  # noqa: E501
        'card_number': 'card_number',  # noqa: E501
        'one_time_token': 'one_time_token',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """TokenizedCardInformation - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            token_id (str): [optional]  # noqa: E501
            masked_card_number (str): 1st 6 and last 4 digits of the card. [optional]  # noqa: E501
            cardholder_name (str, none_type): Cardholder name is optional but recommended for 3DS 2 / AVS verification. [optional]  # noqa: E501
            expiry_month (str): Card expiry month in MM format. [optional]  # noqa: E501
            expiry_year (str): Card expiry month in YY format. [optional]  # noqa: E501
            fingerprint (str): Xendit-generated identifier for the unique card number. Multiple payment method objects can be created for the same account - e.g. if the user first creates a one-time payment request, and then later on creates a multiple-use payment method using the same account.   The fingerprint helps to identify the unique account being used.. [optional]  # noqa: E501
            type (str): Whether the card is a credit or debit card. [optional]  # noqa: E501
            network (str): Card network - VISA, MASTERCARD, JCB, AMEX, DISCOVER, BCA. [optional]  # noqa: E501
            country (str): Country where the card was issued ISO 3166-1 Alpha-2. [optional]  # noqa: E501
            issuer (str): Issuer of the card, most often an issuing bank For example, “BCA”, “MANDIRI”. [optional]  # noqa: E501
            card_number (str): [optional]  # noqa: E501
            one_time_token (str): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                elif isinstance(arg, str):
                    kwargs.update({"value": arg})
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self,
        token_id: str | None = None,
        masked_card_number: str | None = None,
        cardholder_name: str | None = None,
        expiry_month: str | None = None,
        expiry_year: str | None = None,
        fingerprint: str | None = None,
        type: str | None = None,
        network: str | None = None,
        country: str | None = None,
        issuer: str | None = None,
        card_number: str | None = None,
        one_time_token: str | None = None,
        *args, **kwargs
    ):  # noqa: E501
        """TokenizedCardInformation - a model defined in OpenAPI


        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            token_id (str): [optional]  # noqa: E501
            masked_card_number (str): 1st 6 and last 4 digits of the card. [optional]  # noqa: E501
            cardholder_name (str, none_type): Cardholder name is optional but recommended for 3DS 2 / AVS verification. [optional]  # noqa: E501
            expiry_month (str): Card expiry month in MM format. [optional]  # noqa: E501
            expiry_year (str): Card expiry month in YY format. [optional]  # noqa: E501
            fingerprint (str): Xendit-generated identifier for the unique card number. Multiple payment method objects can be created for the same account - e.g. if the user first creates a one-time payment request, and then later on creates a multiple-use payment method using the same account.   The fingerprint helps to identify the unique account being used.. [optional]  # noqa: E501
            type (str): Whether the card is a credit or debit card. [optional]  # noqa: E501
            network (str): Card network - VISA, MASTERCARD, JCB, AMEX, DISCOVER, BCA. [optional]  # noqa: E501
            country (str): Country where the card was issued ISO 3166-1 Alpha-2. [optional]  # noqa: E501
            issuer (str): Issuer of the card, most often an issuing bank For example, “BCA”, “MANDIRI”. [optional]  # noqa: E501
            card_number (str): [optional]  # noqa: E501
            one_time_token (str): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                elif isinstance(arg, str):
                    kwargs.update({"value": arg})
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        if token_id is not None:
            self.token_id = token_id
        if masked_card_number is not None:
            self.masked_card_number = masked_card_number
        if cardholder_name is not None:
            self.cardholder_name = cardholder_name
        if expiry_month is not None:
            self.expiry_month = expiry_month
        if expiry_year is not None:
            self.expiry_year = expiry_year
        if fingerprint is not None:
            self.fingerprint = fingerprint
        if type is not None:
            self.type = type
        if network is not None:
            self.network = network
        if country is not None:
            self.country = country
        if issuer is not None:
            self.issuer = issuer
        if card_number is not None:
            self.card_number = card_number
        if one_time_token is not None:
            self.one_time_token = one_time_token
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
