"""
    The version of the XENDIT API: 1.70.0
"""


import re  # noqa: F401
import sys  # noqa: F401
from typing import List  # noqa: F401

from xendit.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from xendit.exceptions import ApiAttributeError

from xendit.payment_request.model.card_parameters import CardParameters
from xendit.payment_request.model.direct_debit_parameters import DirectDebitParameters
from xendit.payment_request.model.e_wallet_parameters import EWalletParameters
from xendit.payment_request.model.over_the_counter_parameters import OverTheCounterParameters
from xendit.payment_request.model.payment_method_reusability import PaymentMethodReusability
from xendit.payment_request.model.payment_method_type import PaymentMethodType
from xendit.payment_request.model.qr_code_parameters import QRCodeParameters
from xendit.payment_request.model.virtual_account_parameters import VirtualAccountParameters
globals()['CardParameters'] = CardParameters
globals()['DirectDebitParameters'] = DirectDebitParameters
globals()['EWalletParameters'] = EWalletParameters
globals()['OverTheCounterParameters'] = OverTheCounterParameters
globals()['PaymentMethodReusability'] = PaymentMethodReusability
globals()['PaymentMethodType'] = PaymentMethodType
globals()['QRCodeParameters'] = QRCodeParameters
globals()['VirtualAccountParameters'] = VirtualAccountParameters

def lazy_import():
    pass

class PaymentMethodParameters(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'type': (PaymentMethodType,),  # noqa: E501
            'reusability': (PaymentMethodReusability,),  # noqa: E501
            'description': (str, none_type, none_type),  # noqa: E501
            'reference_id': (str, none_type),  # noqa: E501
            'card': (CardParameters, none_type),  # noqa: E501
            'direct_debit': (DirectDebitParameters, none_type),  # noqa: E501
            'ewallet': (EWalletParameters, none_type),  # noqa: E501
            'over_the_counter': (OverTheCounterParameters, none_type),  # noqa: E501
            'virtual_account': (VirtualAccountParameters, none_type),  # noqa: E501
            'qr_code': (QRCodeParameters, none_type),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'type': 'type',  # noqa: E501
        'reusability': 'reusability',  # noqa: E501
        'description': 'description',  # noqa: E501
        'reference_id': 'reference_id',  # noqa: E501
        'card': 'card',  # noqa: E501
        'direct_debit': 'direct_debit',  # noqa: E501
        'ewallet': 'ewallet',  # noqa: E501
        'over_the_counter': 'over_the_counter',  # noqa: E501
        'virtual_account': 'virtual_account',  # noqa: E501
        'qr_code': 'qr_code',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, type, reusability, *args, **kwargs):  # noqa: E501
        """PaymentMethodParameters - a model defined in OpenAPI

        Args:
            type (PaymentMethodType):
            reusability (PaymentMethodReusability):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            description (str, none_type): [optional]  # noqa: E501
            reference_id (str): [optional]  # noqa: E501
            card (CardParameters): [optional]  # noqa: E501
            direct_debit (DirectDebitParameters): [optional]  # noqa: E501
            ewallet (EWalletParameters): [optional]  # noqa: E501
            over_the_counter (OverTheCounterParameters): [optional]  # noqa: E501
            virtual_account (VirtualAccountParameters): [optional]  # noqa: E501
            qr_code (QRCodeParameters): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                elif isinstance(arg, str):
                    kwargs.update({"value": arg})
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.type = type
        self.reusability = reusability
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self,
        type: PaymentMethodType,
        reusability: PaymentMethodReusability,
        description: str | None = None,
        reference_id: str | None = None,
        card: CardParameters | None = None,
        direct_debit: DirectDebitParameters | None = None,
        ewallet: EWalletParameters | None = None,
        over_the_counter: OverTheCounterParameters | None = None,
        virtual_account: VirtualAccountParameters | None = None,
        qr_code: QRCodeParameters | None = None,
        *args, **kwargs
    ):  # noqa: E501
        """PaymentMethodParameters - a model defined in OpenAPI

        Args:
            type (PaymentMethodType):
            reusability (PaymentMethodReusability):


        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            description (str, none_type): [optional]  # noqa: E501
            reference_id (str): [optional]  # noqa: E501
            card (CardParameters): [optional]  # noqa: E501
            direct_debit (DirectDebitParameters): [optional]  # noqa: E501
            ewallet (EWalletParameters): [optional]  # noqa: E501
            over_the_counter (OverTheCounterParameters): [optional]  # noqa: E501
            virtual_account (VirtualAccountParameters): [optional]  # noqa: E501
            qr_code (QRCodeParameters): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                elif isinstance(arg, str):
                    kwargs.update({"value": arg})
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.type = type
        self.reusability = reusability
        if description is not None:
            self.description = description
        if reference_id is not None:
            self.reference_id = reference_id
        if card is not None:
            self.card = card
        if direct_debit is not None:
            self.direct_debit = direct_debit
        if ewallet is not None:
            self.ewallet = ewallet
        if over_the_counter is not None:
            self.over_the_counter = over_the_counter
        if virtual_account is not None:
            self.virtual_account = virtual_account
        if qr_code is not None:
            self.qr_code = qr_code
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
